class Libscrypt < Formula
  desc "Library for scrypt"
  homepage "https://github.com/technion/libscrypt"
  url "https://github.com/technion/libscrypt/archive/refs/tags/v1.22.tar.gz"
  sha256 "a2d30ea16e6d288772791de68be56153965fe4fd4bcd787777618b8048708936"
  license "BSD-2-Clause"

  def install
    # `-Os` leads to bugs. https://github.com/technion/libscrypt/issues/60
    ENV.O1

    args = ["PREFIX=#{prefix}"]
    install_target = "install"

    if OS.mac?
      args += %w[CFLAGS_EXTRA=-fstack-protector LDFLAGS= LDFLAGS_EXTRA=]
      install_target << "-osx"
    end

    system "make", "check", *args
    system "make", install_target, *args
    system "make", "install-static", *args

    return if OS.mac?

    prefix.install "libscrypt.version"
  end

  test do
    (testpath/"test.c").write <<~EOS
      #include <libscrypt.h>
      int main(void) {
        char buf[SCRYPT_MCF_LEN];
        libscrypt_hash(buf, "Hello, Homebrew!", SCRYPT_N, SCRYPT_r, SCRYPT_p);
      }
    EOS
    system ENV.cc, "test.c", "-L#{lib}", "-lscrypt", "-o", "test"
    system "./test"
  end
end
